Index: uspace/srv/net/structures/packet/packet_client.h
===================================================================
--- uspace/srv/net/structures/packet/packet_client.h	(revision 21580dd3dd9a49828a6c8dd3988e651a60708c10)
+++ uspace/srv/net/structures/packet/packet_client.h	(revision 858fc9083f1f538a864233e8551633863fb17e0b)
@@ -59,5 +59,5 @@
  *  @returns NULL if there is not enough memory left.
  */
-#define PACKET_PREFIX( packet, type )	( type * ) packet_prefix(( packet ), sizeof( type ))
+#define PACKET_PREFIX(packet, type)	(type *) packet_prefix((packet), sizeof(type))
 
 /** Allocates the specified type right after the actual packet content and returns its pointer.
@@ -69,5 +69,5 @@
  *  @returns NULL if there is not enough memory left.
  */
-#define PACKET_SUFFIX( packet, type )	( type * ) packet_suffix(( packet ), sizeof( type ))
+#define PACKET_SUFFIX(packet, type)	(type *) packet_suffix((packet), sizeof(type))
 
 /** Trims the actual packet content by the specified prefix and suffix types.
@@ -80,5 +80,5 @@
  *  @returns ENOMEM if there is not enough memory left.
  */
-#define PACKET_TRIM( packet, prefix, suffix )	packet_trim(( packet ), sizeof( prefix ), sizeof( suffix ))
+#define PACKET_TRIM(packet, prefix, suffix)	packet_trim((packet), sizeof(prefix), sizeof(suffix))
 
 /** Allocates the specified space right before the actual packet content and returns its pointer.
@@ -88,5 +88,5 @@
  *  @returns NULL if there is not enough memory left.
  */
-void *	packet_prefix( packet_t packet, size_t length );
+void * packet_prefix(packet_t packet, size_t length);
 
 /** Allocates the specified space right after the actual packet content and returns its pointer.
@@ -96,5 +96,5 @@
  *  @returns NULL if there is not enough memory left.
  */
-void *	packet_suffix( packet_t packet, size_t length );
+void * packet_suffix(packet_t packet, size_t length);
 
 /** Trims the actual packet content by the specified prefix and suffix lengths.
@@ -106,5 +106,5 @@
  *  @returns ENOMEM if there is not enough memory left.
  */
-int	packet_trim( packet_t packet, size_t prefix, size_t suffix );
+int packet_trim(packet_t packet, size_t prefix, size_t suffix);
 
 /** Copies the specified data to the beginning of the actual packet content.
@@ -117,5 +117,5 @@
  *  @returns ENOMEM if there is not enough memory left.
  */
-int	packet_copy_data( packet_t packet, const void * data, size_t length );
+int packet_copy_data(packet_t packet, const void * data, size_t length);
 
 /** Returns the packet identifier.
@@ -124,5 +124,5 @@
  *  @returns Zero (0) if the packet is not valid.
  */
-packet_id_t packet_get_id( const packet_t packet );
+packet_id_t packet_get_id(const packet_t packet);
 
 /** Returns the packet content length.
@@ -131,5 +131,5 @@
  *  @returns Zero (0) if the packet is not valid.
  */
-size_t	packet_get_data_length( const packet_t packet );
+size_t packet_get_data_length(const packet_t packet);
 
 /** Returns the pointer to the beginning of the packet content.
@@ -138,5 +138,5 @@
  *  @returns NULL if the packet is not valid.
  */
-void *	packet_get_data( const packet_t packet );
+void * packet_get_data(const packet_t packet);
 
 /** Returns the stored packet addresses and their length.
@@ -148,5 +148,5 @@
  *  @returns EINVAL if the packet is not valid.
  */
-int	packet_get_addr( const packet_t packet, uint8_t ** src, uint8_t ** dest );
+int packet_get_addr(const packet_t packet, uint8_t ** src, uint8_t ** dest);
 
 /** Sets the packet addresses.
@@ -159,5 +159,5 @@
  *  @returns ENOMEM if there is not enough memory left.
  */
-int	packet_set_addr( packet_t packet, const uint8_t * src, const uint8_t * dest, size_t addr_len );
+int packet_set_addr(packet_t packet, const uint8_t * src, const uint8_t * dest, size_t addr_len);
 
 /** Translates the packet identifier to the packet reference.
@@ -172,5 +172,5 @@
  *  @returns Other error codes as defined for the packet_return() function.
  */
-int packet_translate( int phone, packet_ref packet, packet_id_t packet_id );
+int packet_translate(int phone, packet_ref packet, packet_id_t packet_id);
 
 /** Obtains the packet of the given dimensions.
@@ -184,5 +184,5 @@
  *  @returns NULL on error.
  */
-packet_t packet_get_4( int phone, size_t max_content, size_t addr_len, size_t max_prefix, size_t max_suffix );
+packet_t packet_get_4(int phone, size_t max_content, size_t addr_len, size_t max_prefix, size_t max_suffix);
 
 /** Obtains the packet of the given content size.
@@ -193,5 +193,5 @@
  *  @returns NULL on error.
  */
-packet_t packet_get_1( int phone, size_t content );
+packet_t packet_get_1(int phone, size_t content);
 
 /** Releases the packet queue.
@@ -202,5 +202,5 @@
  *  @param[in] packet_id The packet identifier.
  */
-void pq_release( int phone, packet_id_t packet_id );
+void pq_release(int phone, packet_id_t packet_id);
 
 /** Returns the packet copy.
@@ -212,5 +212,5 @@
  *  @returns NULL on error.
  */
-packet_t	packet_get_copy( int phone, packet_t packet );
+packet_t packet_get_copy(int phone, packet_t packet);
 
 /*@}*/